rem arguments
rem %1 database alias/name
rem %2 user name (schema owner)
rem %3 user password


echo IRM 3.1: Start database upgrade to FP1: %date% %time% > IRM31FP1.log

db2 connect to %1 user %2 using %3 >> IRM31FP1.log
if %errorlevel% NEQ 0 goto FAIL

db2 -v -s "call TS_Utility_GetIRMVersion(?)"  >> IRM31FP1.log

if NOT %errorlevel% EQU  0 (
	goto FAIL
)


db2 -v -s "select 1 from ts_cnfgrgstry where cnfgRgstryTyp = 0 AND cnfgrgstrykey = 'IRMDBVersion' AND cnfgRgstryVal = '3.1.0.26.1 - DB2 8.1'" >> IRM31FP1.log
if NOT %errorlevel% EQU 0 (
	echo ERROR: incorrect IRM database version >> IRM31FP1.log
	goto FAIL
)

rem DROP stored procedures
db2 -v -s drop procedure TS_FlPlnCmpnt_FetchActnMskLstByUsrs >> IRM31FP1.log
db2 -v -s drop procedure TS_Utility_GetNameForAuditActnMsk >> IRM31FP1.log
db2 -v -s drop procedure TS_Utility_GetIRMVersion  >> IRM31FP1.log

rem CREATE NEW FUNCTIONS

db2 -v -s "select 1 from syscat.functions where funcname = UPPER('TS_ACP_GetEffPermL') and funcschema = CURRENT SCHEMA"  >> IRM31FP1.log
if %errorlevel% EQU 0 (
 	db2 -v -s  drop function TS_ACP_GetEffPermL   >> IRM31FP1.log
)

db2 -v -td@ -s -f TS_ACP_GetEffPermL.fn2  >> IRM31FP1.log
if %errorlevel% NEQ 2 goto FAIL

rem REPLACE FUNCTIONS

rem TS_FPR_GetACPDsc 
db2 -v -s  "select 1 from syscat.functions where funcname = UPPER('TS_FPR_GetACPDsc') and funcschema = CURRENT SCHEMA"  >> IRM31FP1.log
if %errorlevel% EQU 0 (
 	db2 -v -s drop function TS_FPR_GetACPDsc  >> IRM31FP1.log
)

db2 -td@ -v -s -f TS_FPR_GetACPDsc.fn2  >> IRM31FP1.log
if %errorlevel% NEQ 2 goto FAIL


rem TS_FPR_GetDscBySrc
db2 -v -s  "select 1 from syscat.functions where funcname = UPPER('TS_FPR_GetDscBySrc') and funcschema = CURRENT SCHEMA"  >> IRM31FP1.log
if %errorlevel% EQU 0 (
 	db2 -v -s drop function TS_FPR_GetDscBySrc  >> IRM31FP1.log
)

db2 -v -td@ -s -f TS_FPR_GetDscBySrc.fn2  >> IRM31FP1.log
if %errorlevel% NEQ 2 goto FAIL



rem PUT NEW STORED PROCEDURES


db2 -v -s drop procedure TS_FlPlnCmpnt_FetchActnMskLstByUsrs >> IRM31FP1.log
db2 -v -s drop procedure TS_Utility_GetNameForAuditActnMsk >> IRM31FP1.log
db2 -v -s drop procedure TS_Utility_GetIRMVersion  >> IRM31FP1.log

db2 -v PUT ROUTINE FROM TS_FlPlnCmpnt_FetchActnMskLstByUsrs.sar OWNER %2 USE REGISTERS  >> IRM31FP1.log
if %errorlevel% NEQ 0 goto FAIL

db2 -v PUT ROUTINE FROM TS_Utility_GetNameForAuditActnMsk.sar OWNER %2 USE REGISTERS >> IRM31FP1.log
if %errorlevel% NEQ 0 goto FAIL

rem bump up the version
db2 -v PUT ROUTINE FROM TS_Utility_GetIRMVersion.sar OWNER %2 USE REGISTERS >> IRM31FP1.log
if %errorlevel% NEQ 0 goto FAIL


rem update the config registry table to reflect the new version

db2 -v -s "call TS_Utility_GetIRMVersion(?)"  >> IRM31FP1.log

rem rebind stored procedures
db2 -x "select 'rebind package ' || substr(implementation, 1,8)  || '@' from syscat.routines r join syscat.packages p on substr(implementation, 1,8) = p.pkgname and routineschema = pkgschema where p.valid = 'X'" > rebind.db2
db2 -td@ -v -s -f rebind.db2  >> IRM31FP1.log

db2 terminate

echo .
echo Done.
echo Done. >> IRM31FP1.log
exit 0

:FAIL
echo Errors, check the log file
echo Errors encountered >> IRM31FP1.log
exit -1

